/* 
 * Copyright (c) 2023 yann pascaud
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License along with this program.
 * If not, see https://www.gnu.org/licenses/
 */
#include "ButtonHD.h"

ButtonHD::ButtonHD()
{
  _longPress = true;
}

void ButtonHD::setHeldDownTime(uint32_t time)
{
  heldDownTime = time;
}

uint32_t ButtonHD::getHeldDownTime()
{
  return heldDownTime;
};

bool ButtonHD::isHeldDown()
{
  return (isPressed() && currentDuration() >= heldDownTime);
};

bool ButtonHD::heldDown()
{
  if (isHeldDown() and !_longPress)
  {
    _longPress = true;
    return true;
  }
  return false;
};

bool ButtonHD::update()
{
  if (Bounce2::Button::update())
  {
    _longPress = false;
    return true;
  }
  return false;
}